// RCC_AHB1ENR.GPIOCEN -- RCC offset 0x30, bit 2
  {
    register uint32_t tmp1, tmp2;
    __asm volatile(
      "movs  %[t1], #1    "     "\n\t"
      "ldr   %[t2], [%[p2], #48]    "     "\n\t"
      "orr   %[t2], #4 "     "\n\t"
        "ldr  %[tick_start], [%[cyccnt]]" "\n\t"  // tick_start
      "str   %[t2], [%[p2], #48]    "     "\n\t"
#if(NOP_NR >= 1)
      "nop"                     "\n\t"
#endif
#if(NOP_NR >= 2)
      "nop"                     "\n\t"
#endif
#if(DSB_NR)
      "dsb"                     "\n\t"
#endif
#if(READ_ENABLE)
      "ldr   %[t2], [%[p2], #48]    "     "\n\t"  // readback of RCC enable register
#elif(READ_PERIPHERAL)
      "ldr   %[t2], [%[p], #0x14]    "     "\n\t"
#else
    // nothing
#endif
      "str   %[t1], [%[p], #0x14]" "\n\t"
        "ldr   %[tick_end], [%[cyccnt]]" "\n\t"  // tick_end

      "nop"                     "\n\t"
      "nop"                     "\n\t"
      "nop"                     "\n\t"

      :[t1] "=&r" (tmp1)
      ,[t2] "=&r" (tmp2)
      ,[tick_start] "=&r" (tick_start)
      ,[tick_end] "=&r" (tick_end)
      :[p]   "r" (GPIOC)
      ,[p2]   "r" (RCC)
      ,[cyccnt] "r" (DWT_CYCCNT)
    );
  }

  result[test_nr] = (GPIOC->ODR == 1);
  ticks[test_nr] = tick_end - tick_start;

  RCC->AHB1RSTR = RCC_AHB1RSTR_GPIOCRST;
  RCC->AHB1RSTR = 0;
  RCC->AHB1ENR &= ~RCC_AHB1ENR_GPIOCEN;
    __asm("nop");
    __asm("nop");
    __asm("nop");
    __asm("nop");
// end of test
